typedef long INT;
typedef short SHORT;

#include <stdio.h>
#include <malloc.h>



# define	NO_REDUCE		0L		/*	TPMcD	*/
# define	POWER_REDUCE	1L		/*	TPMcD	*/
# define	STD_BASIS		2L		/*	TPMcD	*/


#ifdef ULTRIX
#define HP500
#include <malloc.h>
#endif /* ULTRIX */

#define ANFANG 1L
#define ENDE 2L
#define REPORT 3L
#define TRUE 1L
#define FALSE 0L

#define OK 0L
#define ERROR -1L
#define not !
#define IMPROPER 1001L /* MD */

#define FREE (char)1
#define NOFREE (char)0


/* definitionen fuer object.c */
typedef long OBJECTKIND;  /* long statt char AK 290692 */
typedef union {
	INT ob_INT;
	char *ob_INTpointer;
	char *ob_charpointer;
	struct bruch *ob_bruch;
	struct graph *ob_graph;
	struct list *ob_list;
	struct longint *ob_longint;
	struct matrix *ob_matrix;
	struct monom *ob_monom;
	struct number *ob_number; /* MD */
	struct partition *ob_partition;
	struct permutation *ob_permutation;
	struct skewpartition *ob_skewpartition;
	struct symchar *ob_symchar;
	struct tableaux *ob_tableaux;
	struct vector *ob_vector;
	} OBJECTSELF;

struct object { OBJECTKIND ob_kind; OBJECTSELF ob_self; };
typedef struct object * OP;

/* die verschiedenen typen */

#define AUG_PART (OBJECTKIND)12
#define BINTREE (OBJECTKIND)24 /* 291288 */
#define BRUCH (OBJECTKIND)4
#define BTREE (OBJECTKIND)30
#define COMP (OBJECTKIND)26 /* 300889 */
#define CYCLOTOMIC (OBJECTKIND) 124 /* MD */
#define EMPTY (OBJECTKIND)0 /* 290590 */
#define INTEGER (OBJECTKIND)1
#define INTEGERVECTOR (OBJECTKIND)15
#define INTINT (OBJECTKIND)17	/* nur fuer test-zwecke */
#define GEN_CHAR (OBJECTKIND)23 /* 280888 */
#define GRAL (OBJECTKIND)32 /* 200691 */
#define GRAPH (OBJECTKIND)25 /* 210889 */
#define HOM_SYM (OBJECTKIND)13
#define KOSTKA (OBJECTKIND)16
#define KRANZTYPUS (OBJECTKIND)27 /* 280390 */
#define KRANZ (OBJECTKIND)31
#define LIST (OBJECTKIND)20 /* 210688 */
#define LONGINT (OBJECTKIND)22 /* 170888 */
#define MATRIX (OBJECTKIND)11
#define MONOM (OBJECTKIND)21 /*230688*/
#define MONOPOLY (OBJECTKIND) 126 /* MD */
#define PARTITION (OBJECTKIND)3
#define PERMUTATION (OBJECTKIND)6
#define POLYNOM (OBJECTKIND)9
#define SCHUBERT (OBJECTKIND)14
#define SCHUR (OBJECTKIND)10
#define SKEWPARTITION (OBJECTKIND)7  /* 020488 */
#define SQ_RADICAL (OBJECTKIND) 125 /* MD */
#define SYMCHAR (OBJECTKIND)18
#define TABLEAUX (OBJECTKIND)8  /* 020488 */
#define VECTOR (OBJECTKIND)2
#define WORD (OBJECTKIND)19


#ifdef DGUX
#define static  /* noetig fuer profile */
#define signed 
#endif /* DGUX */

#ifdef sun
#define signed 
#endif
#ifdef hpux
#define signed 
#endif



struct loc
{ 
   INT w2,w1,w0;
   struct loc *nloc;
  };

struct longint
{
   struct loc *floc;
   signed char signum; /* -1,0,+1 */
   INT laenge;
};


struct ganzdaten
{
   INT basis,basislaenge,vorrat,speicher,auspos,auslaenge,auszz;
   unsigned char folgezeichen;
   struct loc *floc;
};

struct zahldaten
{
   signed char ziffer[13];
   INT mehr;
   INT  ziffernzahl;
   struct loc  *fdez;
};


struct vector { OP v_length; OP v_self; };

struct list { OP l_self; OP l_next; };

struct partition { OBJECTKIND pa_kind; OP pa_self; };
#define LASTPARTITION 1234
#define EXPONENT (OBJECTKIND)88
#define LASTCOMP 1234L

struct permutation { OBJECTKIND p_kind; OP p_self; };
#define LASTLEHMERCODE 12L
#define LASTPERMUTATION 13L
#define LAST_PERMUTATION 13L
#define LASTSHUFFLE 12048802L
#define ZYKEL (OBJECTKIND)40888	/* fuer zykelschreibweise */
#define BAR (OBJECTKIND)25		/* AK 260292 fuer barred perm */
#define BARCYCLE (OBJECTKIND)26		/* AK 260292 fuer barred perm */

struct monom { OP mo_self;  OP mo_koeff;  };

struct bruch { OP b_oben; OP b_unten; };

struct matrix { OP m_length; OP m_height; OP m_self; };
#define SINGULAER 2903884

struct skewpartition { OP spa_gross; OP spa_klein; };

struct tableaux { OP t_umriss;  OP t_self; };

struct symchar{ OP sy_werte; OP sy_parlist; OP sy_dimension; };

struct graph {  OBJECTKIND gr_kind; OP   gr_self; };
#define NACHBARLISTE (OBJECTKIND) 1

typedef struct { OP index, deg, poly, autos; } CYCLO_DATA; /* MD */
typedef struct { OP index, deg, poly; } FIELD_DATA; /* MD */
union data { CYCLO_DATA *c_data; FIELD_DATA *f_data; OP o_data; } ; /* MD */
struct number { OP n_self; union data n_data; };  /* MD */

/* return value fuer insert */
#define INSERTEQ 301288  /* falls eq */
#define INSERTOK 3012881  /* falls insert */

#ifdef ALLTRUE
#define INTEGERTRUE 1
#define VECTORTRUE 1
#define PARTTRUE 1
#define PERMTRUE 1
#define LONGINTTRUE 1
#define MATRIXTRUE 1
#define SCHURTRUE 1
#define HOMSYMTRUE 1
#define BRUCHTRUE 1
#define CHARTRUE 1
#define KOSTKATRUE 1
#define SCHUBERTTRUE 1
#define SHUFFLETRUE 1
#define SKEWPARTTRUE 1
#define TABLEAUXTRUE 1
#define WORDTRUE 1
/* #define GRAPHTRUE 1 AK 181291 */
#define KRANZTRUE 1
#define BINTREETRUE 1
#define MONOPOLYTRUE 1
#define SQRADTRUE 1
#define CYCLOTRUE 1
#define NUMBERTRUE 1
#define DGTRUE 1
#define WTTRUE 1
#define SABTRUE 1
#define PLETTRUE 1
#define ZONALTRUE 1
#endif

#ifdef DGTRUE
#define SABTRUE 1    
/* for gl-m reps */
#define MATRIXTRUE 1
#define CHARTRUE 1
#define PARTTRUE 1
#define NUMBERTRUE 1
#endif

#ifdef ZONALTRUE
#define KOSTKATRUE 1
#define CHARTRUE 1
#define MATRIXTRUE 1
#define POLYNOMTRUE 1
#define PARTTRUE 1
#endif

#ifdef NUMBERTRUE
#define INTEGERTRUE 1
#define BRUCHTRUE 1
#define LISTTRUE 1
#define MONOMTRUE 1
#define SQRADTRUE 1
#define CYCLOTRUE 1
#define MONOPOLYTRUE 1
#endif

#ifdef PLETTRUE
#define SCHURTRUE 1
#define MATRIXTRUE 1
#define CHARTRUE 1
#endif

#ifdef SKEWPARTTRUE
#define PARTTRUE 1
#endif 

#ifdef KOSTKATRUE
#define MATRIXTRUE 1
#define SCHURTRUE 1
#endif

#ifdef CHARTRUE
#define INTEGERTRUE 1
#define LONGINTTRUE 1
#define VECTORTRUE 1
#define PARTTRUE 1
#define MATRIXTRUE 1
#define SCHURTRUE 1
#define BRUCHTRUE 1
#define KOSTKATRUE 1
#define NUMBERTRUE 1
#define SQRADTRUE 1
#define CYCLOTRUE 1
#define MONOPOLYTRUE 1
#endif

#ifdef SCHUBERTTRUE
#define POLYTRUE 1
#define PARTTRUE 1
#define PERMTRUE 1
#define VECTORTRUE 1
#define INTEGERTRUE 1
#endif


#ifdef SCHURTRUE
#define BINTREETRUE 1
#define POLYTRUE 1
#define PARTTRUE 1
#define PERMTRUE 1
#define INTEGERTRUE 1
#define VECTORTRUE 1
#define SKEWPARTTRUE 1
#endif

#ifdef BINTREETRUE
#define INTEGERTRUE 1
#endif

#ifdef POLYTRUE
#define LISTTRUE 1
#define MONOMTRUE 1
#define VECTORTRUE 1
#endif

#ifdef PERMTRUE
#define PARTTRUE 1
#define INTEGERTRUE 1
#define VECTORTRUE 1
#endif
#ifdef PARTTRUE
#define INTEGERTRUE 1
#define VECTORTRUE 1
#endif

#ifdef VECTORTRUE
#define INTEGERTRUE 1
#endif


extern OP cons_eins;
extern OP cons_null;
extern OP cons_zwei;
extern FILE *texout;
extern INT zeilenposition;
extern INT texposition;
extern OP *speicher;
extern INT speicherposition;
#define SPEICHERSIZE 1000L

#ifdef LONGINTTRUE
extern struct ganzdaten gd; /* a global datastructure */
#endif

extern INT		absolute();
extern INT		add();
extern INT		add_apply();
extern INT		add_apply_integer();
extern INT		add_apply_integer_integer();
extern INT		add_apply_integer_longint();
extern INT		add_apply_longint();
extern INT		add_apply_longint_integer();
extern INT		add_apply_longint_longint();
extern INT		add_apply_polynom_schubert();
extern INT		add_bruch();
extern INT		add_bruch_bruch();
extern INT		add_cyclo();
extern INT		add_integer();
extern INT 		add_koeff();
extern INT 		add_longint();
extern INT 		add_longint_integer();
extern INT		add_matrix();
extern INT		add_monom();
extern INT		add_monom_schur();
extern INT		add_partition();
extern INT		add_polynom();
extern INT		add_polynom_polynom();
extern INT		add_scalar_cyclo();
extern INT		add_scalar_monopoly();
extern INT		add_scalar_sqrad();
extern INT		add_schubert_schubert();
extern INT		add_schur_schur();
extern INT		add_symchar();
extern INT		add_vector();
extern INT		addinvers();
extern INT		addinvers_bruch();
extern INT		addinvers_integer();
extern INT		addinvers_longint();
extern INT		addinvers_monom();
extern INT		addinvers_polynom();
extern INT		addinvers_schur();
extern INT		addinvers_symchar();
extern INT		addinvers_vector();
extern INT		addinvers_apply();
extern INT		addinvers_apply_bruch();
extern INT		addinvers_apply_integer();
extern INT		addinvers_apply_longint();
extern INT		addinvers_apply_monom();
extern INT		addinvers_apply_polynom();
extern INT		addinvers_apply_schur();
extern INT		addinvers_apply_symchar();
extern INT		addinvers_apply_vector();
extern INT		an_tafel();
extern INT 		append();
extern INT		b_d_sc();
extern INT		b_gk_spa();
extern INT		b_i_pa();
extern INT		b_ks_pa();
extern INT		b_ksd_n();
extern INT		b_ks_p();
extern INT		b_l_nv();
extern INT		b_l_v();
extern INT		b_lhs_m();
extern INT		b_lh_m();
extern INT		b_lh_nm();
extern INT		b_ls_v();
extern INT		b_ou_b();
extern INT		b_pa_s();
extern INT		b_sk_mo();
extern INT		b_skn_mp();
extern INT		b_skn_po();
extern INT		b_skn_sch();
extern INT		b_skn_s();
extern INT		b_sn_l();
extern INT		b_s_po();
extern INT		b_us_t();
extern INT		b_wpd_sc();
extern OP 		callocobject();
extern INT		carre_comp();
extern INT		carre_operation();
extern INT		characteristik_to_symchar();
extern INT		chartafel();
extern INT		charvalue();
extern INT		c_i_i();
extern INT		c_l_n();
extern INT		c_l_s();
extern INT              c_o_k();
extern INT		comp_colex_part();
extern INT		comp_colex_schurmonom();
extern INT		comp_cyclo();
extern INT		columnwordoftableaux();
extern INT		comp();
extern INT		comp_bruch();
extern INT		comp_cyclo();
extern INT		comp_integer();
extern INT		comp_lex_perm();
extern INT		comp_matrix();
extern INT		comp_monom();
extern INT		comp_monomvector_monomvector();
extern INT		comp_partition();
extern INT		comp_permutation();
extern INT		comp_permutation_pol();
extern INT		comp_sqrad();
extern INT		comp_tableaux();
extern INT		compute_complete_with_alphabet();
extern INT		compute_monomial_with_alphabet();
extern INT		compute_power_with_alphabet();
extern INT		compute_schur_with_alphabet();
extern INT		compute_schur_with_alphabet_det();
extern INT		conj_sqrad();
extern INT		conjugate();
extern INT		conjugate_partition();
extern INT		conjugue();
extern INT              c_o_s();
extern INT		c_pa_k();
extern INT		c_pa_s();
extern INT		c_p_k();
extern INT		c_p_s();
extern INT 		c_sch_n();
extern INT 		c_sc_d();
extern INT 		c_sc_p();
extern INT 		c_sc_w();
extern INT              c_s_k();
extern INT              c_s_n();
extern INT		co040989();
extern INT		co090889();
extern INT		co_170790();
extern INT		comp();
extern INT		comp_bruch();
extern INT		comp_bruch_scalar();
extern INT		comp_integer();
extern INT		comp_monomvector_monomvector();
extern INT              complete_schur_plet();
extern INT              convert_cyclo_scalar();
extern INT              convert_sqrad_scalar();
extern INT 		copy();
extern INT 		copy_imatrix(); 
extern INT 		copy_integer();
extern INT 		copy_list();
extern INT 		copy_matrix();
extern INT 		copy_monom();
extern INT 		copy_partition();
extern INT 		copy_permutation();
extern INT 		copy_polynom();
extern INT 		copy_skewpartition();
extern INT		c_t_s();
extern INT		c_t_u();
extern INT		c_v_i();
extern INT		debugprint();
extern INT		debugprint_object();
extern INT 		dec();
extern INT 		dec_integer();
extern INT 		dec_longint();
extern INT 		dec_partition();
extern INT 		dec_permutation();
extern INT 		dec_vector();
extern INT		det();
extern INT		det_imm_matrix();
extern INT		det_matrix();
extern INT		det_mat_imm();
extern INT		det_mat_tri();
extern INT		dimension();
extern INT		dimension_augpart();
extern INT              dimension_part();
extern INT              dimension_symmetrization();
extern INT              dimino();
extern INT		div();
extern INT		divideddifference();
extern INT		divideddiff_permutation();
extern INT		einsp();
extern INT		einsp_integer();
extern INT		emptyp();
extern INT		empty_listp();
extern INT 		error();
extern INT 		eq();
extern INT		even();
extern INT		even_integer();
extern INT		even_longint();
extern INT		even_permutation();
extern INT		fakul();
extern INT		fakul_longint();
extern INT		fastconjugate_partition();
extern INT		field_check_cyclo();
extern INT		field_check_sqrad();
extern INT		fill_left_down_matrix();
extern INT		first_partition();
extern INT		first_permutation();
extern INT 		fprint();
extern INT 		fprint_integer();
extern INT 		fprintln();
extern INT 		fprint_skewpartition();
extern INT 		freeall();
extern INT 		free_loc();
extern INT 		freeself();
extern INT 		freeself_bruch();
extern INT 		freeself_monom();
extern INT 		freeself_permutation();
extern INT 		freeself_partition();
extern INT 		freeself_skewpartition();
extern INT 		fusedmemory();
extern INT              ganzdiv();
extern INT              ganzdiv_integer();
extern INT              ganzdiv_longint();
extern INT		gausspoly();
extern INT		get_level_vector_of_verband();
extern INT              gewicht_v();
extern INT              gewicht_wt();
extern INT              ggt();
extern INT              ggt_i();
extern INT              glmndg();
extern INT              glpdg();
extern INT              gr();
extern INT		hall_littlewood();
extern INT		hall_littlewood_dij();
extern INT		hall_littlewood_tafel();
extern INT		hoch();
extern INT		homtest();
extern INT		hoook_part();
extern INT		immanente_matrix();
extern INT		inc();
extern INT		inc_integer();
extern INT		inc_longint();
extern INT		inc_matrix();
extern INT		inc_partition();
extern INT		inc_permutation();
extern INT		inc_tableaux();
extern INT		inc_vector();
extern INT		indexofpart();
extern INT		inhalt();
extern INT		inhalt_tableaux();
extern INT              init();
extern INT              init_hall_littlewood();
extern INT              init_kostka();
extern INT              init_longint();
extern INT              inner_tensor_sc();
extern INT              insert();
extern INT              insert_bt_bt();
extern INT              insert_list();
extern INT              insert_list_list_2();
extern INT              integer_factor();
extern INT              intlog();
extern INT		invers();
extern INT		invers_bruch();
extern INT		invers_integer();
extern INT		invers_matrix();
extern INT		invers_permutation();
extern INT		kostka_kostka();
extern INT		kostka_number();
extern INT		kostka_number_partition();
extern INT		kostka_number_skewpartition();
extern INT		kostka_tafel();
extern INT		kronecker_product();
extern INT		kuerzen();
extern INT		lagrange_polynom();
extern INT		last();
extern INT		last_partition();
extern INT		last_permutation();
extern INT		lastof();
extern INT		lastof_skewpartition();
extern INT		latex_line();
extern INT		latex_verband();
extern INT		le();
extern INT		leftkey_wt();
extern INT		lehmercode();
extern INT		lehmercode_permutation();
extern INT		lehmercode_tableaux();
extern INT		lehmercode_vector();
extern INT		length();
extern INT		length_list();
extern INT		length_partition();
extern INT		length_vector();
extern INT 		listp();
extern INT 		lt();
extern INT		make_neu_partij_schur();
extern INT		make_n_kostka();
extern INT		make_scalar_cyclo();
extern INT		makevectorofpart();
extern INT		makevectoroftranspositions();
extern INT              matrix_monom_ypolynom();
extern INT		max();
extern INT		max_vector();
extern INT		maximalplace();
extern INT		maxrindexword();
extern INT		m_d_sc();
extern INT		memcheck();
extern INT		m_gk_spa();
extern INT 		m_i_i();
extern INT 		m_i_longint();
extern INT 		m_ilih_m();
extern INT 		m_ilih_nm();
extern INT 		m_il_p();
extern INT 		m_il_nv();
extern INT 		m_il_v();
extern INT 		m_index_monom();
extern INT 		m_iindex_iexponent_monom();
extern INT 		m_i_pa();
extern INT 		m_i_v();
extern INT		m_kl_pa();
extern INT              m_ks_o();
extern INT              m_ks_p();
extern INT              m_ks_pa();
extern INT		m_lh_m();
extern INT		m_lhs_m();
extern INT              m_l_nv();
extern INT              m_l_v();
extern INT              m_l_w();
extern INT              m_matrix_umriss();
extern INT              m_part_kostkaperm();
extern INT 		m_perm_schubert_monom_summe();
extern INT 		m_perm_tableaux_summe();
extern INT		m_scalar_bruch();
extern INT		m_scalar_polynom();
extern INT		m_scalar_schur();
extern INT              m_sk_mo();
extern INT              m_skn_po();
extern INT              m_skn_s();
extern INT              m_sn_l();
extern INT              m_T_pol_summe();
extern INT		mod();
extern INT		mod_integer();
extern INT		mod_longint();
extern INT		m_ou_b();
extern INT              m_pa_s();
extern INT              m_part_sc();
extern INT              m_part_sc_tafel();
extern INT		m_s_po();
extern INT		m_tableaux_tableauxpair();
extern INT		mult();
extern INT		mult_apply();
extern INT		mult_apply_bruch();
extern INT		mult_apply_integer();
extern INT		mult_apply_integer_integer();
extern INT		mult_apply_integer_longint();
extern INT		mult_apply_longint();
extern INT		mult_apply_longint_integer();
extern INT		mult_apply_longint_longint();
extern INT		mult_apply_scalar_matrix();
extern INT		mult_apply_scalar_polynom();
extern INT		mult_apply_polynom();
extern INT		mult_apply_polynom_polynom();
extern INT		mult_apply_vector_vector();
extern INT		mult_bruch();
extern INT		mult_homsym_homsym();
extern INT		mult_integer();
extern INT		mult_imatrix_imatrix();
extern INT		mult_longint();
extern INT		mult_longint_integer();
extern INT		mult_longint_longint();
extern INT		mult_matrix();
extern INT		mult_matrix_matrix();
extern INT		mult_matrix_vector();
extern INT		mult_permutation();
extern INT		mult_polynom();
extern INT		mult_polynom_polynom();
extern INT		mult_power_part();
extern INT		mult_scalar_bruch();
extern INT		mult_scalar_cyclo();
extern INT		mult_scalar_matrix();
extern INT		mult_scalar_monom();
extern INT		mult_scalar_polynom();
extern INT		mult_scalar_schubert();
extern INT		mult_scalar_schur();
extern INT		mult_scalar_sqrad();
extern INT		mult_scalar_symchar();
extern INT		mult_scalar_vector();
extern INT		mult_schur_schur();
extern INT		mult_symchar_symchar();
extern INT		mult_vector_matrix();
extern INT		mult_vector_vector();
extern INT		m_umriss_tableaux();
extern INT		m_us_t();
extern INT		m_u_t();
extern INT		m_v_pa();
extern INT		m_v_s();
extern INT		m_wpd_sc();
extern INT		m_wt_tableaux();
extern INT		m_wttab_tableaux();
extern INT		m_wt_wtkontertab();
extern INT		m_wt_wttab();
extern INT		nb_quores();
extern INT		ndg();
extern INT		negeinsp();
extern INT		negeinsp_bruch();
extern INT		negp();
extern INT		negp_integer();
extern INT		neq();
extern INT              newtrans();
extern INT              newtrans_main_limit();
extern INT              newtrans_start();
extern INT              newtrans_nextstep();
extern INT		next();
extern INT		next_composition();
extern INT		next_lehmercode();
extern INT		next_part_EXPONENT();
extern INT		next_partition();
extern INT		next_part_VECTOR();
extern INT		next_permutation();
extern INT		next_shufflepermutation();
extern INT              nullp();
extern INT              nullp_cyclo();
extern INT              nullp_integer();
extern INT              nullp_monopoly();
extern INT              nullp_sqrad();
extern INT              nullp_vector();
extern INT              numberof_inversionen();
extern INT              numberofpart();
extern INT              numberofpart_i();
extern INT              numberofvariables();
extern INT		objectread();
extern INT		objectread_integer();
extern INT		objectread_longint();
extern INT		objectread_matrix();
extern INT		objectread_partition();
extern INT		objectread_permutation();
extern INT		objectread_vector();
extern INT		objectwrite();
extern INT		objectwrite_integer();
extern INT		objectwrite_longint();
extern INT		objectwrite_matrix();
extern INT		objectwrite_partition();
extern INT		objectwrite_permutation();
extern INT		objectwrite_vector();
extern INT		odg();
extern INT		operate_gral_polynom();
extern INT		operate_perm_polynom();
extern INT		operate_perm_vector();
extern INT		ordcen();
extern INT		ordcon();
extern INT		outerproduct_schur();
extern INT		partitionp();
extern INT		perm_matrix();
extern INT		perm_tableaux();
extern INT		perm_weintraube();
extern INT		pictex_wt();
extern INT              pl_j_wt();
extern INT		posp();
extern INT		posp_integer();
extern INT              power_schur_plet();
extern INT		prepartdom();
extern INT              print();
extern INT              printeingabe();
extern INT              println();
extern INT              printobjectkind();
extern INT              pr_j_wt();
extern INT              p_root_part();
extern INT              p_root_schur();
extern INT		quadraticp();
extern INT		random();
extern INT		random_integer();
extern INT		random_longint();
extern INT		random_partition();
extern INT		random_permutation();
extern INT		reduce_symchar();
extern INT		reduce_symchar_tafel();
extern INT		reorder_hall_littlewood();
extern INT		rightkey_wt();
extern INT		rindexword();
extern INT		rindexword_sub();
extern INT		rowwordoftableaux();
extern INT		rz();
extern INT		rz_lc();
extern INT		rz_perm();
extern OP		s_b_o();
extern INT		s_b_oi();
extern OP		s_b_u();
extern INT		s_b_ui();
extern INT		scan();
extern INT		scan_monopoly_co();
extern INT		scan_permutation_cycle();
extern OBJECTKIND	scanobjectkind();
extern INT		scalarp();
extern INT		scalarproduct();
extern INT		scalarproduct_symchar();
extern INT		scalarproduct_vector();
extern INT		schicht_print();
extern INT		schur_schur_plet();
extern INT              sdg();
extern INT              signum();
extern INT              signum_permutation();
extern INT              s_i_i();
extern INT              s_i_wt();
extern OP		s_l_n();
extern OP		s_l_s();
extern OP		s_m_h();
extern INT		s_m_hi();
extern OP               s_m_ij();
extern INT              s_m_iji();
extern OP		s_m_l();
extern INT		s_m_li();
extern OP               s_mo_s();
extern OP               s_mo_k();
extern INT              s_mo_ki();
extern OBJECTKIND       s_o_k();
extern INT		sort();
extern INT		sort_vector();
extern OBJECTSELF       s_o_s();
extern INT		spaltenanfang();
extern INT		spaltenende();
extern INT		specht_dg();
extern INT		specht_irred_characteristik();
extern INT		specht_m_part_sc();
extern INT		specht_poly();
extern INT		specht_powersum();
extern OP 		s_p_i();
extern INT              s_p_ii();
extern OP 		s_p_l();
extern INT              s_p_li();
extern OBJECTKIND       s_p_k();
extern OP 		s_p_s();
extern OP  		s_pa_i();
extern INT              s_pa_ii();
extern OBJECTKIND       s_pa_k();
extern OP               s_pa_l();
extern INT              s_pa_li();
extern OP               s_pa_s();
extern OP               s_po_k();
extern OP               s_po_n();
extern OP               s_po_s();
extern OP               s_po_si();
extern INT              s_po_sii();
extern OP 		s_po_sl();
extern INT              s_po_sli();
extern INT              squareroot();
extern INT              squareroot_integer();
extern INT              squareroot_longint();
extern INT		S_rofword();
extern OP		s_sch_k();
extern OP		s_sch_n();
extern OP		s_sch_s();
extern OP		s_sc_d();
extern OP		s_sc_p();
extern OP		s_sc_pi();
extern INT		s_sc_pli();
extern OP		s_sc_w();
extern OP		s_sc_wi();
extern INT		s_sc_wli();
extern OP               s_s_k();
extern OP               s_s_n();
extern OP		s_spa_g();
extern OP		s_spa_k();
extern OP               s_s_s();
extern INT		starpart();
extern INT		start_longint();
extern INT		starttableaux();
extern OP		s_t_h();
extern INT		s_t_hi();
extern OP               s_t_ij();
extern INT              s_t_iji();
extern INT              stirling_second_number();
extern INT              stirling_second_number_tafel();
extern INT              stirling_second_tafel();
extern OP		s_t_l();
extern INT		s_t_li();
extern OP		s_t_s();
extern OP		s_t_u();
extern INT 		sub();
extern INT 		sum();
extern INT 		sum_vector();
extern OP  		s_v_i();
extern INT 		s_v_ii();
extern OP 		s_v_l();
extern INT 		s_v_li();
extern OP  		s_v_s();
extern INT		swap();
extern OP		s_w_i();
extern INT		s_w_ii();
extern OP		s_w_l();
extern INT		s_w_li();
extern INT		S_wt();
extern INT		s_x_nu_to_ypolynom();
extern INT		test_bruch();
extern INT		test_part();
extern INT		tex();
extern INT		tex_dia_wt();
extern INT		tex_hall_littlewood();
extern INT		tex_integer();
extern INT		tex_list();
extern INT		tex_longint();
extern INT		tex_matrix();
extern INT		tex_monom();
extern INT		tex_partition();
extern INT		tex_permutation();
extern INT		tex_polynom();
extern INT		tex_schubert();
extern INT		tex_schur();
extern INT		tex_tableaux();
extern INT		tex_vector();
extern INT 		t_BINTREE_LIST();
extern INT 		t_EXPONENT_VECTOR();
extern INT 		t_VECTOR_EXPONENT();
extern INT 		t_ZYKEL_VECTOR();
extern INT 		t_vperm_zperm();
extern INT 		t_zperm_vperm();
extern INT		time();
extern INT		t_longint_int();
extern INT		trace();
extern INT		trace_matrix();
extern INT		trans();
extern INT		transformlist();
extern INT		transpose();
extern INT		transpose_matrix();
extern INT		typusorder();
extern INT		UD_permutation();
extern INT		vander_gen();
extern INT		vexillaryp();
extern INT		vexillaryp_permutation();
extern INT		weight();
extern INT		weight_augpart();
extern INT		weight_partition();
extern INT		weight_skewpartition();
extern INT		weight_tableaux();
extern INT		weintraube_vector();
extern INT		wordoftableaux();
extern INT		wt_liste_gewicht();
extern INT		young_character();
extern INT		zeilenanfang();
extern INT              zeilenende();
extern INT              zykelind_arb();
extern INT              zykelind_An();
extern INT              zykelind_Cn();
extern INT              zykelind_Dn();
extern INT              zykelind_Sn();
extern INT		zykeltyp_permutation();


/* aus nc.c */
extern INT a_charvalue();
extern INT ak_make_alt_classes();
extern INT ak_make_alt_partitions();
extern INT alt_dimension();
extern INT class_rep_kranz();
extern INT grouporder_kranz();
extern INT hook_part();
extern INT m_gl_alt();
extern INT m_gl_chartafel();
extern INT m_gl_cl();
extern INT m_gl_co();
extern INT m_gl_cr();
extern INT m_gl_go();
extern INT m_gl_hyp();
extern INT m_gl_il();
extern INT m_gl_nc();
extern INT m_gl_sym();
extern INT m_gl_symkranz();
extern INT m_nc_alt();
extern INT m_nc_kranz();
extern INT m_nc_sym();
extern INT m_vcl_kranz();
extern INT m_vco_kranz();
extern INT m_vec_grad_nc_hyp();
extern INT make_alt_classes();
extern INT make_alt_partitions();
extern INT makealtclassreps();
extern INT mult_nc_kranz();
extern INT numberof_class_kranz();
extern INT order_class_kranz();
extern INT part_comp();
extern INT reduce_nc();
extern INT reduce_nc_kranz();
extern INT scalarproduct_nc();
extern INT scan_gl_nc();
extern INT scan_nc_kranz();
extern INT split();
extern INT std_perm();
extern INT wert();
extern INT which_part();
